#import "progid:ShockwaveFlash.ShockwaveFlash" rename_namespace("Flash")

#include <atlbase.h>
#include <atlwin.h>
#include <string.h>
#include <Windows.h>

#define DEFAULT_FLASH TEXT("flash.swf")
#define ID_PLAY 101
#define ID_STOP 102
#define ID_LOAD 103

#define WIN_W 600
#define WIN_H 550

#define BUTTON_W 60
#define BUTTON_H 20
#define BUTTON_STEP 15

CComModule _ccm;
HINSTANCE ghInst;
HWND ghWnd;

DWORD GetOpenName(TCHAR * outbuf, const TCHAR * filter, const TCHAR * title)
{
	OPENFILENAME ofn = {0};
	TCHAR buf[MAX_PATH + 2];

	GetModuleFileName(ghInst, buf, MAX_PATH);

	TCHAR * tmp = StrRChr(buf, NULL, L'\\');
	if(tmp != 0)
	{
		*tmp = 0;
		ofn.lpstrInitialDir = buf;
	}

	ofn.hInstance = ghInst;
	ofn.hwndOwner = ghWnd;
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFilter = filter;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = outbuf;
	ofn.lpstrFile[0] = 0;
	ofn.lpstrFile[1] = 0;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrTitle = title;
	ofn.Flags = OFN_EXPLORER | OFN_DONTADDTORECENT | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NONETWORKBUTTON | OFN_PATHMUSTEXIST;

	return GetOpenFileName(&ofn);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
    static Flash::IShockwaveFlash * flash_o;
	static HWND hWndAX, play, stop, load;
	static RECT rc;
	WCHAR file_path[MAX_PATH];
    
    ghWnd = hWnd;
	

    switch(uMessage)
    {
        case WM_CREATE:

			GetClientRect(ghWnd, &rc);
            
			play = CreateWindow
			(
				L"button",
				L"Play",
				WS_CHILD | WS_VISIBLE,
				rc.left + BUTTON_STEP, rc.bottom - 25, BUTTON_W, BUTTON_H,
				hWnd,
				(HMENU) ID_PLAY,
				NULL,
				NULL
			);

			stop = CreateWindow
			(
				L"button",
				L"Stop",
				WS_CHILD | WS_VISIBLE,
				rc.left + BUTTON_W + BUTTON_STEP, rc.bottom - 25, BUTTON_W, BUTTON_H,
				hWnd,
				(HMENU) ID_STOP,
				NULL,
				NULL
			);

			load = CreateWindow
			(
				L"button",
				L"Load",
				WS_CHILD | WS_VISIBLE,
				rc.left + BUTTON_W + BUTTON_W + BUTTON_STEP, rc.bottom - 25, BUTTON_W, BUTTON_H,
				hWnd,
				(HMENU) ID_LOAD,
				NULL,
				NULL
			);
			
            hWndAX = CreateWindowEx
			(
				0,
				CAxWindow2::GetWndClassName(),
				NULL,
				WS_CHILD | WS_VISIBLE,
                0,
				0,
				WIN_W,
				WIN_H - 70,
				hWnd,
				NULL,
				ghInst,
				NULL
			);

            if
			(
				FAILED
				(
					CoCreateInstance
					(
						__uuidof(Flash::ShockwaveFlash),
						NULL,
						CLSCTX_ALL,
						__uuidof(Flash::IShockwaveFlash),
						(void**)&flash_o
					)
				)
			)
				return -1;

            if(FAILED(AtlAxAttachControl(flash_o, hWndAX, NULL)))
            {
				flash_o->Release();
				return -1;
            }

            GetCurrentDirectory(MAX_PATH, file_path);
			swprintf_s(file_path, MAX_PATH, L"%ws\\%ws", file_path, DEFAULT_FLASH);

            flash_o->LoadMovie(0, file_path);
            flash_o->Menu = VARIANT_FALSE;

			GetWindowRect(hWnd, &rc);

            SetWindowPos
            (
                hWnd,
                NULL,
                (GetSystemMetrics(SM_CXSCREEN) - rc.right) / 2,
                (GetSystemMetrics(SM_CYSCREEN) - rc.bottom) / 2,
                0,
                0,
                SWP_NOZORDER | SWP_NOSIZE
            );
			
        return 0;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case ID_PLAY:
					flash_o->Play();
				break;
				case ID_STOP:
					flash_o->Stop();
				break;
				case ID_LOAD:
					if(GetOpenName(file_path, TEXT("Flash (*.swf)\0*.swf\0  (*.*)\0*.*\0\0"), TEXT("...")))
						flash_o->LoadMovie(0, file_path);
				break;
			}
		return 0;

		case WM_SIZE:
			MoveWindow(hWndAX, 0, 0, LOWORD(lParam), HIWORD(lParam) - 70, TRUE);
			
			GetClientRect(hWnd, &rc);
			MoveWindow(play, rc.left + BUTTON_STEP, rc.bottom - 25, BUTTON_W, BUTTON_H, TRUE);
			MoveWindow(stop, rc.left + BUTTON_W + BUTTON_STEP, rc.bottom - 25, BUTTON_W, BUTTON_H, TRUE);
			MoveWindow(load, rc.left + BUTTON_W + BUTTON_W + BUTTON_STEP, rc.bottom - 25, BUTTON_W, BUTTON_H, TRUE);
		return 0;
        
        case WM_CLOSE:
            DestroyWindow(hWndAX);
			DestroyWindow(hWnd);
        return 0;
        
        case WM_DESTROY:
            flash_o->Release();
            PostQuitMessage(0);
        return 0;
    }
    
    return DefWindowProc(hWnd, uMessage, wParam, lParam);
}

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrev, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASS wc = {0};
	MSG msg;
	ghInst = hInstance;

    CoInitialize(NULL);
    AtlAxWinInit();
	
	wc.lpszClassName = L"swf";
	wc.hInstance     = hInstance;
	wc.hbrBackground = GetSysColorBrush(COLOR_3DFACE);
	wc.lpfnWndProc   = WndProc;
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);

    
    if(!RegisterClass(&wc))
        return MessageBox(HWND_DESKTOP, L"RegisterClass", L"Error", MB_ICONERROR | MB_OK);

	HWND hWnd = CreateWindow
	(
		wc.lpszClassName,
		L"swf",
		WS_OVERLAPPEDWINDOW | WS_VISIBLE,
		0, 0, WIN_W, WIN_H,
		NULL,
		NULL,
		hInstance,
		NULL
	); 
	
    if(!hWnd)
        return MessageBox(HWND_DESKTOP, L"CreateWindow", L"Error", MB_ICONERROR | MB_OK);
    
   
    while(GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    
    CoUninitialize();
    
    return msg.wParam;
}
